/*

IFT1169 - Surcharge des oprateurs - Exemple 01 -

31-janvier		- 2015 v1.03	M.Lokbani - gcc 4.9.2
05-novembre		- 2013 v1.02	M.Lokbani - GCC 4.8.1  avec -std=c++11
21-janvier		- 2006 v1.01	M.Lokbani - gcc 3.4.2.
18-octobre		- 2003 v1.00	M.Lokbani - Extrait des notes de cours.


contact: lokbani@iro.umontreal.ca

        
    Copyright (C) 1999-2015 Universit de Montral
            Dpartement d'informatique et de Recherche Oprationnelle
            Mohamed Lokbani
    -- Tous Droits Rservs -- All Rights Reserved --

Description:
------------
    La surcharge des oprateurs.
    Dans cet exemple nous allons surcharger l'oprateur +=, en le redfinissant
    comme fonction non membre de la classe. On dfinit quand mme la mthode
    amie pour lui permettre l'accs aux membres privs de la classe.
    
    Voir notes de cours, 4: tude du cas de l'oprateur +=

*/
#include <iostream>

using namespace std;

class compte {
	double actif;
public:
	// constructeur
	compte(double i=0):actif(i) {}
	// affiche l'actif
	void affiche() {
		cout << "actif: " << actif << endl;
	}
	// surcharge de l'oprateur +=
	friend void operator+=(compte&,double);
};

/*
    L'oprateur += a t dclar friend afin de lui permettre
    l'accs aux donnes private de la classe compte.
*/

void operator+=(compte& c, double d){
	c.actif += d;
}

int main() {
	compte X(200.89);
	X+=10.50;
	operator+=(X,10.50);
	X.affiche(); // actif: 221.89
	return 0;
}

/*
    >01surop
    actif: 221.89
    >Exit code: 0

*/
