/*

IFT1169 - Surcharge des oprateurs - Exemple 03 -

09-fvrier		- 2015 v1.03	M.Lokbani - GCC 4.9.2  avec -std=c++11
05-novembre		- 2013 v1.02	M.Lokbani - GCC 4.8.1  avec -std=c++11
21-janvier		- 2006 v1.01	M.Lokbani  - gcc 3.4.2.
18-octobre		- 2003 v1.00	M.Lokbani  - Extrait des notes de cours.


contact: lokbani@iro.umontreal.ca

        
    Copyright (C) 1999-2015 Universit de Montral
            Dpartement d'informatique et de Recherche Oprationnelle
            Mohamed Lokbani
    -- Tous Droits Rservs -- All Rights Reserved --

Description:
------------
    La surcharge des oprateurs.
    Dans cet exemple nous allons surcharger l'oprateur de sortie << en le redfinissant
    d'abord comme fonction non membre d'une classe donne. Du coup nous avons besoin
    de l'amiti dans cet exemple pour lui permettre d'accder aux membres privs.
    
    Voir notes de cours, 5: tude du cas de l'oprateur <<

*/

#include <iostream>

using namespace std ;

class compte {
    double actif;
public:
    compte(double i=0):actif(i) {} // constructeur
    friend ostream& operator<<(ostream&,const compte&); // surcharge de l'oprateur <<
    friend void operator+=(compte&,double); // surcharge de l'oprateur +=
};

/*
    Oprateurs << et += ont t dclars friend afin de leur permettre l'accs
    aux donnes private de la classe compte. cout est dfinie dans la classe
    ostream (output stream ou flux de sortie), d'o la dclaration du type de
    out. On passe l'objet c par constante, vu qu'on ne fait qu'afficher le
    contenu de c. On retourne un ostream pour permettre l'enchanement des
    oprations sur la sortie standard, exemple:
    cout << "1er opration vers cout" << "2e opration vers cout" << "etc..";
*/

ostream& operator<<(ostream& out, const compte& c){
    out << "actif: " << c.actif << endl;
    return out;
}

// On pouvait inclure operator+= comme fonction membre de la classe compte.

void operator+=(compte& c,double d){
    c.actif += d;
}

int main() {
    compte X(200.89);
    X+=10.50;
    cout << X; // actif: 211.39
    return 0;
}

/*
    >03surop
        actif: 211.39
    >Exit code: 0
*/
