/*

IFT1169 - Surcharge des oprateurs - Exemple 05 -

09-fvrier		- 2015 v1.00	M.Lokbani - GCC 4.9.2  avec -std=c++11


contact: lokbani@iro.umontreal.ca

        
    Copyright (C) 1999-2015 Universit de Montral
            Dpartement d'informatique et de Recherche Oprationnelle
            Mohamed Lokbani
    -- Tous Droits Rservs -- All Rights Reserved --

Description:
------------
    La surcharge des oprateurs.
    Dans cet exemple nous allons tester des arguments passs par rfrence de la catgorie Lvalue ou Rvalue.
        
    Voir notes de cours, 9.2: Les rfrences dans le cas de "RValue"
    
*/

#include <iostream>

using namespace std;

// -1- Rfrence Lvalue
void test(int& ref) {
	cout << "lref: " << ref << endl;
}

// -2- Rfrence Rvalue
void test(int&& ref) {
	cout << "rref: " << ref << endl;
}

// -3- Rfrence pour une constante Lvalue
void test(const int& ref) {
	cout << "const: " << ref << endl;
}


int main(){
	
	const int z = 50;
	
	int w = 30;
	
	// -3-
	test(z);
	
	// =1-
	test(w);
	
	// -2-
	test(77);

//	Erreur
//	error: invalid initialization of non-const reference of type 'int&' from an rvalue of type 'int'	
//	int &k = 10;

	int zz = 20;
	int&& xx = zz + 30; // xx=50 et extension dure de vie

	xx+=10; // xx=60
	cout << "xx:" << xx << endl;
	cout << "zz:" << zz << endl;

	// -2-
	test(std::move(w));
	cout << "w:" << w << endl;
	
	w++;
	
	cout << "w:" << w << endl;

	return 0;
}