/*

IFT1169 - Surcharge des oprateurs - Exemple 05 -

09-fvrier		- 2015 v1.00	M.Lokbani - GCC 4.9.2  avec -std=c++11


contact: lokbani@iro.umontreal.ca

        
    Copyright (C) 1999-2015 Universit de Montral
            Dpartement d'informatique et de Recherche Oprationnelle
            Mohamed Lokbani
    -- Tous Droits Rservs -- All Rights Reserved --

Description:
------------
    La surcharge des oprateurs.
    Dans cet exemple nous allons dfinir les mthodes par dfaut disponible dans une classe version C++11
        
    Voir notes de cours, 10: les mthodes par dfaut dans une classe, version C++11.
    
*/

#include <iostream>

using namespace std;

class Test {
public:
	Test(){
		cout << "Constructeur: " << this << "\n";
	}
	Test(const Test& T){
		cout << "Recopie: " << this << "\n";
	}
	Test(Test&& T){
		cout << "Constructeur de deplacement: " << this << "\n";
	}
	Test& operator=(const Test& T){
		cout << "Operateur affectation: " << this << "\n";
		return (*this);
	}
	Test& operator=(Test&& T){
		cout << "Operateur deplacement: " << this << "\n";
		return (*this);
	}
	~Test(){
		cout << "Destructeur: " << this << "\n";
	}
};


Test Essai(Test x){
	cout << "Essai\n";
	return x;
}

int main(){
	Test a; //Constructeur
	Test b = a; // Recopie
	Test c; // Constructeur
	a=c; // Affectation
	
	// Recopie pour le passage d'argument
	// Constructeur de dplacement puis oprateur de dplacement
	// Destructeur de x, local  Essai, destruction de l'objet temporaire
	b = Essai(a); 
	
	cout << "Le temps des destructeurs\n";
	return 0;
}
	