/*

IFT1169 - Surcharge des oprateurs - Exemple 07 -

10-fvrier		- 2015 v1.03	M.Lokbani - GCC 4.9.2  avec -std=c++11, move
05-novembre	- 2013 v1.02	M.Lokbani - GCC 4.8.1  avec -std=c++11
21-janvier		- 2006 v1.01	M.Lokbani  - gcc 3.4.2.
18-octobre		- 2003 v1.00	M.Lokbani  - Extrait des notes de cours.


contact: lokbani@iro.umontreal.ca

        
    Copyright (C) 1999-2015 Universit de Montral
            Dpartement d'informatique et de Recherche Oprationnelle
            Mohamed Lokbani
    -- Tous Droits Rservs -- All Rights Reserved --

Description:
------------
    La surcharge des oprateurs.

    Dans cet exemple nous allons introduire le constructeur de dplacement et l'oprateur de dplacement
    dans le cas d'un tableau. Nous allons dfinir aussi la mthode swap pour profiter de ces dfinition.
    Nous pouvions aussi utiliser la mthode swap dfinie par le langage.
    
    Voir notes de cours, 10: Mthode par dfaut d'une classe.

*/

#include <iostream>
#include <chrono>
#include <ctime>

using namespace std;

class tableau {
	int n; // la taille du tableau tab
	double *tab; // pointeur vers un tableau de double
	void alloc_test(){ // test d'allocation mmoire
		if (tab==NULL) {
			cerr << "allocation de la mmoire a chou !\n";
			exit(1);
		}
	}
	void index_test(int taille_entree){ // test la taille du tableau
		if (taille_entree<1) {
			cerr << "taille du tableau  allouer est infrieure ou gale  zro! \n";
			exit(1);
		}
	}
	void recopie_elt(const tableau& T) { // recopie lment par lment
		for (int i=0;i<n;i++) tab[i] = T.tab[i];
	}
public:
	tableau(int x) { // constructeur
		index_test(x);
		tab = new double[n=x]; // allocation
		alloc_test();
	}

	~tableau(){ // destructeur
		delete [] tab; // libration de la mmoire alloue.
	}

	tableau(const tableau& T) { // constructeur de recopie
		tab = new double[n=T.n];
		alloc_test();
		recopie_elt(T);
	}

	// Constructeur de dplacement
	tableau(tableau&& T){
		tab = T.tab;
		n = T.n;
		T.tab = nullptr;
		T.n = 0;
		cout << "move constructeurr\n";
	}

	tableau& operator=(const tableau& T) { // oprateur d'affectation
		if (this != &T) { // on teste si on n'affecte pas l'objet  lui-mme.
			delete [] tab; // Si ce n'est pas le cas, on dtruit l'objet existant.
			tab = new double[n=T.n]; // on alloue de la mmoire  nouveau.
			alloc_test(); // test d'allocation.
			recopie_elt(T); // recopie des lments de T.tab  tab.
		}
		return (*this); // on retourne l'objet appelant.
	}

	// move assignment
	tableau& operator=(tableau&& T)  {
		tab = T.tab;
		n = T.n;
		T.tab = nullptr;
		T.n = 0;
		cout << "move assignment\n";
		return *this;
	}

	void init_tab (double nbre){ // initialise tous les lments de tab  nbre.
		for (int i=0;i<n;i++) tab[i] = nbre;
	}

	friend ostream& operator<< (ostream& out,const tableau& T); // sortie 
};

// affichage vers la sortie de tab.
ostream& operator<< (ostream& out,const tableau& T) {
	for (int i=0;i<T.n;i++) out << "tab[" << i << "] " << T.tab[i] << endl;
	return out;
}

void zswap(tableau& A, tableau& B){
	tableau temp = move(A);
	A = move(B);
	B = move(temp);
}


int main() {
	tableau a(5), b(10);
	a.init_tab(25);
	b.init_tab(90);
	cout << "-----------a-------------\n" << a;
	cout << "-----------b-------------\n" << b;
	cout << "-------------------------\n";	
	zswap(a,b);
	cout << "-------------------------\n";
	cout << "-----------a-------------\n" << a;
	cout << "-----------b-------------\n" << b;
	return 0;
}

/*
	>./07surop
		-----------a-------------
		tab[0] 25
		tab[1] 25
		tab[2] 25
		tab[3] 25
		tab[4] 25
		-----------b-------------
		tab[0] 90
		tab[1] 90
		tab[2] 90
		tab[3] 90
		tab[4] 90
		tab[5] 90
		tab[6] 90
		tab[7] 90
		tab[8] 90
		tab[9] 90
		-------------------------
		move constructeurr
		move assignment
		move assignment
		-------------------------
		-----------a-------------
		tab[0] 90
		tab[1] 90
		tab[2] 90
		tab[3] 90
		tab[4] 90
		tab[5] 90
		tab[6] 90
		tab[7] 90
		tab[8] 90
		tab[9] 90
		-----------b-------------
		tab[0] 25
		tab[1] 25
		tab[2] 25
		tab[3] 25
		tab[4] 25
	>Exit code: 0

*/