/*

IFT1169 - Surcharge des oprateurs - Exemple 09 -

10-fvrier		- 2015 v1.03	M.Lokbani - GCC 4.9.2  avec -std=c++11, move
05-novembre	- 2013 v1.02	M.Lokbani - GCC 4.8.1  avec -std=c++11
21-janvier		- 2006 v1.01	M.Lokbani - gcc 3.4.2.
18-octobre		- 2003 v1.00	M.Lokbani - Extrait des notes de cours.


contact: lokbani@iro.umontreal.ca

        
    Copyright (C) 1999-2015 Universit de Montral
            Dpartement d'informatique et de Recherche Oprationnelle
            Mohamed Lokbani
    -- Tous Droits Rservs -- All Rights Reserved --

Description:
------------
    La surcharge des oprateurs.
    Dans cet exemple nous allons surcharger l'oprateur d'affectation [] (indexation)
    et nous allons montrer un bug gnr par l'oprateur [] dans le traitement des
    objets constants.
    
    Voir notes de cours, 11.3: bogue gnr par l'oprateur []

*/

#include <iostream>

using namespace std;

class tableau {

	int n; // la taille du tableau tab
	double *tab; // pointeur vers un tableau de double
	void alloc_test(){ // test d'allocation mmoire
		if (tab==NULL) {
			cerr << "allocation de la mmoire a chou !\n";
			exit(1);
		}
	}
	void index_test(int taille_entree){ // test la taille du tableau
		if (taille_entree<1) {
			cerr << "taille du tableau  allouer est infrieure ou gale  zro! \n";
			exit(1);
		}
	}
	void recopie_elt(const tableau& T) { // recopie lment par lment
		for (int i=0;i<n;i++) tab[i] = T.tab[i];
	}
public:
	tableau(int x) { // constructeur
		index_test(x);
		tab = new double[n=x]; // allocation
		alloc_test();
	}

	~tableau(){ // destructeur
		delete [] tab; // libration de la mmoire alloue.
	}

	tableau(const tableau& T) { // constructeur de recopie
		tab = new double[n=T.n];
		alloc_test();
		recopie_elt(T);
	}
	// Constructeur de dplacement
	tableau(tableau&& T){
		tab = T.tab;
		n = T.n;
		T.tab = nullptr;
		T.n = 0;
		cout << "move constructeurr\n";
	}

	tableau& operator=(const tableau& T) { // oprateur d'affectation
		if (this != &T) { // on teste si on n'affecte pas l'objet  lui-mme.
			delete [] tab; // Si ce n'est pas le cas, on dtruit l'objet existant.
			tab = new double[n=T.n]; // on alloue de la mmoire  nouveau.
			alloc_test(); // test d'allocation.
			recopie_elt(T); // recopie des lments de T.tab  tab.
		}
		return (*this); // on retourne l'objet appelant.
	}

	// move assignment
	tableau& operator=(tableau&& T)  {
		tab = T.tab;
		n = T.n;
		T.tab = nullptr;
		T.n = 0;
		cout << "move assignment\n";
		return *this;
	}

	// redfinition de l'oprateur d'indexation []
	double& operator[](int i) const{
		if ((i>=0) && (i<n)) return tab[i];
		else {
			cerr << "problme avec l'index!\n";
			exit(1);
		}
	}
    
	void init_tab (double nbre){ // initialise tous les lments de tab  nbre.
		for (int i=0;i<n;i++) tab[i] = nbre;
	}

	friend ostream& operator<< (ostream& out,const tableau& T); // sortie 
};

// affichage vers la sortie de tab.
ostream& operator<< (ostream& out,const tableau& T) {
	for (int i=0;i<T.n;i++) out << "tab[" << i << "]= " << T.tab[i] << endl;
	return out;
}

int main() {

	const tableau a(3);

	/*
		On a donc allou un tableau de 3 lments. Nous avons quand mme russi 
		initialiser le 1er lment sachant tout de mme que le tableau a t dclar
		constant d'o l'erreur.
	*/

	a[0] = 38.5;

	cout << "on affiche a ...\n";
	cout << a;

	return 0;
}


/*  noter que la valeur de tab[1] est arbitraire. Il a affich ce qu'il avait entre les mains!!!!

    >09surop
        on affiche a ...
        tab[0]= 38.5
        tab[1]= 4.7599e-317
        tab[2]= 0
    >Exit code: 0

*/
