/*

IFT1169 - Surcharge des oprateurs - Exemple 11 -

10-fvrier		- 2015 v1.03	M.Lokbani - GCC 4.9.2  avec -std=c++11, move
05-novembre	- 2013 v1.02	M.Lokbani - GCC 4.8.1  avec -std=c++11
21-janvier		- 2006 v1.01	M.Lokbani - gcc 3.4.2.
18-octobre		- 2003 v1.00	M.Lokbani - Extrait des notes de cours.


contact: lokbani@iro.umontreal.ca

        
    Copyright (C) 1999-2015 Universit de Montral
            Dpartement d'informatique et de Recherche Oprationnelle
            Mohamed Lokbani
    -- Tous Droits Rservs -- All Rights Reserved --

Description:
------------
    La surcharge des oprateurs.
    Nous allons dcrire dans cet exemple la surcharge de l'oprateur
    d'appel de fonction (). Il est conseill d'utiliser cet oprateur
     la place de l'oprateur d'indexation [] car ce dernier ne permet
    qu'un seul argument ce n'est pas le cas de (). Dans ce exemple nous
    allons surdfinir deux fois ().
    
    Voir notes de cours, 9.12: Oprateur appel de fonction ()

*/

#include <iostream>

using namespace std;

class tableau {

		int n; // la taille du tableau tab
	double *tab; // pointeur vers un tableau de double
	void alloc_test(){ // test d'allocation mmoire
		if (tab==NULL) {
			cerr << "allocation de la mmoire a chou !\n";
			exit(1);
		}
	}
	void index_test(int taille_entree){ // test la taille du tableau
		if (taille_entree<1) {
			cerr << "taille du tableau  allouer est infrieure ou gale  zro! \n";
			exit(1);
		}
	}
	void recopie_elt(const tableau& T) { // recopie lment par lment
		for (int i=0;i<n;i++) tab[i] = T.tab[i];
	}
public:
	tableau(int x) { // constructeur
		index_test(x);
		tab = new double[n=x]; // allocation
		alloc_test();
	}

	~tableau(){ // destructeur
		delete [] tab; // libration de la mmoire alloue.
	}

	tableau(const tableau& T) { // constructeur de recopie
		tab = new double[n=T.n];
		alloc_test();
		recopie_elt(T);
	}
	// Constructeur de dplacement
	tableau(tableau&& T){
		tab = T.tab;
		n = T.n;
		T.tab = nullptr;
		T.n = 0;
		cout << "move constructeurr\n";
	}

	tableau& operator=(const tableau& T) { // oprateur d'affectation
		if (this != &T) { // on teste si on n'affecte pas l'objet  lui-mme.
			delete [] tab; // Si ce n'est pas le cas, on dtruit l'objet existant.
			tab = new double[n=T.n]; // on alloue de la mmoire  nouveau.
			alloc_test(); // test d'allocation.
			recopie_elt(T); // recopie des lments de T.tab  tab.
		}
		return (*this); // on retourne l'objet appelant.
	}

	// move assignment
	tableau& operator=(tableau&& T)  {
		tab = T.tab;
		n = T.n;
		T.tab = nullptr;
		T.n = 0;
		cout << "move assignment\n";
		return *this;
	}

	// redfinition de l'oprateur d'indexation [] cas des objets constants
	double operator[](int i) const{
		cout << "operateur constant\n";
		if ((i>=0) && (i<n)) return tab[i];
		else {
			cerr << "problme avec l'index!\n";
			exit(1);
		}
	}

	// redfinition de l'oprateur d'indexation [] cas des objets non constants
	double& operator[](int i) {
		cout << "operateur non constant\n"; 
		if ((i>=0) && (i<n)) return tab[i];
		else {
			cerr << "problme avec l'index!\n";
			exit(1);
		}
	}

	double operator()(int i,const char* f) {
		// fait quelque chose
		cout << "entier: " << i << " ; la chaine de caracteres: " << f <<endl;
		return double (i);
	}
	// redfini
	int operator()(double j,int k) {
		// fait quelque chose
		cout << "double: " << j << " ; l'entier: " << k <<endl;
		return k;
	}
	
	void init_tab (double nbre){ // initialise tous les lments de tab  nbre.
		for (int i=0;i<n;i++) tab[i] = nbre;
	}

	friend ostream& operator<< (ostream& out,const tableau& T); // sortie
	
};

// affichage vers la sortie de tab.
ostream& operator<< (ostream& out,const tableau& T) {
	for (int i=0;i<T.n;i++) out << "tab[" << i << "]= " << T.tab[i] << endl;
	return out;
}


int main() {
	tableau t(3);
	double x = t(3,"Fred"); // x=t.operator()(3,"Fred");
	cout << "x: " << x << endl;
	int y = t(3.5,7); // x=t.operator()(3.5,7);
	cout << "y: " << y << endl;

	return 0;
}


/*
	>11surop
		entier: 3 ; la chaine de caracteres: Fred
		x: 3
		double: 3.5 ; l'entier: 7
		y: 7
	>Exit code: 0
*/
