/*

IFT1169 - Surcharge des oprateurs - Exemple 12 -

10-fvrier		- 2015 v1.03	M.Lokbani - GCC 4.9.2  avec -std=c++11, move
05-novembre	- 2013 v1.02	M.Lokbani - GCC 4.8.1  avec -std=c++11
21-janvier		- 2006 v1.01	M.Lokbani - gcc 3.4.2.
18-octobre		- 2003 v1.00	M.Lokbani - Extrait des notes de cours.


contact: lokbani@iro.umontreal.ca

        
    Copyright (C) 1999-2015 Universit de Montral
            Dpartement d'informatique et de Recherche Oprationnelle
            Mohamed Lokbani
    -- Tous Droits Rservs -- All Rights Reserved --

Description:
------------
    La surcharge des oprateurs.
    Nous allons dcrire dans cet exemple la surcharge de l'oprateur ++ dans
    les deux cas: prfixe et suffixe.
    
    Voir notes de cours, 13: Oprateurs ++ et --

*/

#include <iostream>

using namespace std;

class compte {
	float solde;
public:
	compte(float m):solde(m) {}
	compte operator++();
	compte operator++(int);
	void afficher();
};

 
compte compte::operator++() {
	solde++;
	return (*this);
}
compte compte::operator++(int n) {
	compte temp = *this;
	solde++;
	return temp;
}
void compte::afficher() {
	cout << "solde: " << solde << endl;
}

int main() {
	compte C1(100);
	compte C2(200);
	compte C3(300);

	C3 = C1++; // <-- postfixe

	C1.afficher(); // solde: 101
	C3.afficher(); // solde: 100

	C3 = ++C2; // <-- prfixe

	C2.afficher(); // solde: 201
	C3.afficher(); // solde: 201
	return 0;
}



/*
    >12surop
        solde: 101
        solde: 100
        solde: 201
        solde: 201
    >Exit code: 0
*/

